'********************************************************************************************
'this program collects responses of output, taxes, spending and F(s) and plots them
'********************************************************************************************
SMPL !START !YEAR
PAGESELECT TimeSeries
%VARS_GRAPHS = "Y_PC_S T_S G_S"
%MODEL5 = "SD2"
%MODEL0 = "SPND_DW SPND_UP TAX_DW TAX_UP"

'collect responses of output, taxes and spending
FOR %VAR {%VARS}
		FOR %IDC {%LIST}
				!j=1
				MATRIX(!HORZ,12) rsp_{%VAR}_{%MODEL5}_{%IDC}
				FOR %MOD {%MODEL0}
						FOR !i=1 TO 3
								FOR !k=1 to !HORZ
									rsp_{%VAR}_{%MODEL5}_{%IDC}(!k,!j) = rsp_{%VAR}_{%MOD}_{%IDC}(!k,!i)
								NEXT
							!j=!j+1
						NEXT
				NEXT
		NEXT
NEXT
'other multiplier specification
FOR %IDC {%LIST}
	!j=1
	MATRIX(!HORZ,12) rsp_y_pc_s_i_{%MODEL5}_{%IDC}
	FOR %MOD {%MODEL0}
		FOR !i=1 TO 3
			FOR !k=1 to !HORZ
				rsp_y_pc_s_i_{%MODEL5}_{%IDC}(!k,!j) = rsp_y_pc_s_{%MOD}_i_{%IDC}(!k,!i)
			NEXT
			!j=!j+1
		NEXT
	NEXT
NEXT

'graph output taxes and spending

'collecting the series
FOR %IDC {%LIST}
	SMPL !START !START+4
	FOR %NAME {%VARS_GRAPHS}
		series rsp_{%NAME}_{%IDC}_EB_dw_l
		series rsp_{%NAME}_{%IDC}_EB_dw_m
		series rsp_{%NAME}_{%IDC}_EB_dw_h
		series rsp_{%NAME}_{%IDC}_EB_up_l
		series rsp_{%NAME}_{%IDC}_EB_up_m
		series rsp_{%NAME}_{%IDC}_EB_up_h
		series rsp_{%NAME}_{%IDC}_TB_dw_l
		series rsp_{%NAME}_{%IDC}_TB_dw_m
		series rsp_{%NAME}_{%IDC}_TB_dw_h
		series rsp_{%NAME}_{%IDC}_TB_up_l
		series rsp_{%NAME}_{%IDC}_TB_up_m
		series rsp_{%NAME}_{%IDC}_TB_up_h
		group rsp_{%NAME}_{%IDC}_g rsp_{%NAME}_{%IDC}_EB_dw_l rsp_{%NAME}_{%IDC}_EB_dw_m rsp_{%NAME}_{%IDC}_EB_dw_h rsp_{%NAME}_{%IDC}_EB_up_l rsp_{%NAME}_{%IDC}_EB_up_m rsp_{%NAME}_{%IDC}_EB_up_h rsp_{%NAME}_{%IDC}_TB_dw_l rsp_{%NAME}_{%IDC}_TB_dw_m rsp_{%NAME}_{%IDC}_TB_dw_h rsp_{%NAME}_{%IDC}_TB_up_l rsp_{%NAME}_{%IDC}_TB_up_m rsp_{%NAME}_{%IDC}_TB_up_h
		mtos(rsp_{%NAME}_{%MODEL5}_{%IDC},  rsp_{%NAME}_{%IDC}_g)
		group rsp_{%NAME}_{%IDC}_g rsp_{%NAME}_{%IDC}_EB_up_l rsp_{%NAME}_{%IDC}_EB_up_m rsp_{%NAME}_{%IDC}_EB_up_h rsp_{%NAME}_{%IDC}_TB_up_l rsp_{%NAME}_{%IDC}_TB_up_m rsp_{%NAME}_{%IDC}_TB_up_h
	NEXT
NEXT

'graph output taxes spending
FOR %IDC {%LIST}
	%FIG = "FIG1"
		FOR %NAME {%VARS_GRAPHS}
			DELETE FIG_{%NAME}_{%IDC}*
			FREEZE({%FIG}_{%NAME}_{%IDC}) rsp_{%NAME}_{%IDC}_g.MIXED band(rsp_{%NAME}_{%IDC}_EB_up_l, rsp_{%NAME}_{%IDC}_EB_up_h) line(rsp_{%NAME}_{%IDC}_EB_up_m, rsp_{%NAME}_{%IDC}_TB_up_l, rsp_{%NAME}_{%IDC}_TB_up_m, rsp_{%NAME}_{%IDC}_TB_up_h)
			{%FIG}_{%NAME}_{%IDC}.OPTION linepat
			{%FIG}_{%NAME}_{%IDC}.ELEM(2) lcolor(red) lpat(dash7) lwidth(1.5)
			{%FIG}_{%NAME}_{%IDC}.ELEM(4) lcolor(red) lpat(dash7) lwidth(1.5)
			{%FIG}_{%NAME}_{%IDC}.ELEM(3) lcolor(red) lpat(solid) lwidth(1.5) sym(circle) symbolsize(4xl)
			{%FIG}_{%NAME}_{%IDC}.ELEM(1) lcolor(blue) lpat(solid) lwidth(1.5) sym(triup) symbolsize(4xl)
			{%FIG}_{%NAME}_{%IDC}.ELEM(1) fcolor(200,200,200)
			{%FIG}_{%NAME}_{%IDC}.AXIS(l) grid zeroline
			{%FIG}_{%NAME}_{%IDC}.SETOBSLABEL(blank) "0" "1" "2" "3" "4" "5"
			{%FIG}_{%NAME}_{%IDC}.OPTIONS backfade(none) backcolor(white)
			{%FIG}_{%NAME}_{%IDC}.AXIS overlap

			IF %NAME = "G_S" THEN
				{%FIG}_{%NAME}_{%IDC}.SETELEM(1) legend("")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(2) legend("Expenditure Based")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(3) legend("90% CI (Expenditure Based)")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(4) legend("")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(5) legend("Tax Based")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(6) legend("90% CI (Tax Based)")

			ELSE
				{%FIG}_{%NAME}_{%IDC}.SETELEM(1) legend("")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(2) legend("")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(3) legend("")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(4) legend("")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(5) legend("")
				{%FIG}_{%NAME}_{%IDC}.SETELEM(6) legend("")

			ENDIF
		RENAME {%FIG}_{%NAME}_{%IDC} fig_{%NAME}_{%IDC}_{%MODEL5}
		NEXT
NEXT
SMPL !START !YEAR
'cleaning
FOR %IDC {%LIST}
	FOR %NAME {%VARS_GRAPHS}
		DELETE rsp_{%NAME}_{%IDC}_EB*
		DELETE rsp_{%NAME}_{%IDC}_TB*
		DELETE rsp_{%NAME}_{%IDC}_g
	NEXT
NEXT
