'*********************************************************************************************************************************************************************************************************************************************
'this program loads the excel data for the disaggregated IMF components: direct taxes, indirect taxes, consumption spending and transfers. However in this paper we use only the division between taxes and spending
''*********************************************************************************************************************************************************************************************************************************************
WFOPEN NewComponents1978-2014_{%DATA_TYPE}.xlsx range="eviews_hierarchical"			'loading data and transforming excel file into Panel

PAGESTRUCT country @date(dateid) 					'structuring the database
PAGERENAME Untitled Panel							'assigning name to the sheet
PAGEUNSTACK country dateid 							'transforming Panel into Time Series
PAGERENAME untitled TimeSeries 					'assigning name to the sheet

PAGESELECT TimeSeries 

FOR %IDC {%LIST}
		SMPL  @all
		'additional variables
		GENR ds_t{%IDC} = r_sh{%IDC} - r_sh{%IDC}(-1)																				
		GENR dl_t{%IDC} = r_lo{%IDC} - r_lo{%IDC}(-1)
           GENR y_{%IDC} = 100*LOG(gdpv{%IDC})
		GENR esi_c{%IDC} = 100*LOG(esi_con{%IDC})
		GENR esi_i{%IDC} = 100*LOG(esi_ind{%IDC})
           GENR dlt_y_{%IDC} = y_{%IDC} - y_{%IDC}(-1)
		GENR p_gdp_{%IDC} = gdp{%IDC}/gdpv{%IDC}
		GENR infl_{%IDC} = 100*LOG(p_gdp_{%IDC}/p_gdp_{%IDC}(-1))
		GENR dtotmk{%IDC} = 100*LOG(totmk{%IDC}/totmk{%IDC}(-1))
		GENR dneer{%IDC} = 100*LOG(neer{%IDC}/neer{%IDC}(-1))
		GENR ly_{%IDC} = LOG(gdpv{%IDC})
		GENR spread{%IDC} = r_lo{%IDC} - r_sh{%IDC}
		GENR y_pc{%IDC} = dlt_y_{%IDC} - 100*LOG(popt{%IDC}/popt{%IDC}(-1))	
		GENR l_pfce{%IDC} = 100*LOG(pfce{%IDC}*1000000)
		GENR l_gfcf{%IDC} = 100*LOG(gfcf{%IDC}*1000000)
		GENR dlt_pfce{%IDC} = l_pfce{%IDC} - l_pfce{%IDC}(-1)
		GENR dlt_gfcf{%IDC} = l_gfcf{%IDC} - l_gfcf{%IDC}(-1)
		GENR pfce_pc{%IDC} = dlt_pfce{%IDC} - 100*LOG(popt{%IDC}/popt{%IDC}(-1))
		GENR gfcf_pc{%IDC} = dlt_gfcf{%IDC} - 100*LOG(popt{%IDC}/popt{%IDC}(-1))
		GENR rec_y_pc{%IDC} = (y_pc{%IDC} < 0)
		'generating a new series using the OECD data for CONS, INV, NE
		GENR l_cpv{%IDC} = 100*LOG(cpv{%IDC})																					
		GENR l_ipv{%IDC} = 100*LOG(ipv{%IDC})   
		GENR l_itv{%IDC} = 100*LOG(itv{%IDC})  
		GENR dlt_CPV{%IDC} = l_cpv{%IDC} - l_cpv{%IDC}(-1)
		GENR dlt_IPV{%IDC} = l_ipv{%IDC} - l_ipv{%IDC}(-1)
		GENR dlt_ITV{%IDC} = l_itv{%IDC} - l_itv{%IDC}(-1)
		GENR cpv_pc{%IDC} = dlt_cpv{%IDC} - 100*LOG(popt{%IDC}/popt{%IDC}(-1))
		GENR ipv_pc{%IDC} = dlt_ipv{%IDC} - 100*LOG(popt{%IDC}/popt{%IDC}(-1))
		GENR itv_pc{%IDC} = dlt_itv{%IDC} - 100*LOG(popt{%IDC}/popt{%IDC}(-1))
		GENR dt_ne{%IDC} = (ne{%IDC} - ne{%IDC}(-1))
		GENR dt_ney{%IDC} = 100*dt_ne{%IDC}/gdpv{%IDC}
		'GENR ne_pc{%IDC} = dlt_ne{%IDC}-(popt{%IDC} - popt{%IDC}(-1))/popt{%IDC}(-1)
		
		'fiscal variables
		GENR exp_{%IDC} = igv{%IDC} + cgv{%IDC} 											'spending
		GENR rev_{%IDC} = yrg{%IDC}/p_gdp_{%IDC} 										'revenues (they are nominal hence must be deflated with GDP deflator)
		GENR transf_{%IDC} = (oco{%IDC} + sspg{%IDC})/p_gdp_{%IDC}				'transfers (they are nominal hence must be deflated with GDP deflator)
		GENR exp_A_{%IDC} = exp_{%IDC} + transf_{%IDC}								'expenditure aggregate
		GENR exp_scaled_{%IDC} = exp_a_{%IDC}/gdpv{%IDC} 							'scaling revenue and expenditure by GDP
		GENR rev_scaled_{%IDC} = rev_{%IDC}/gdpv{%IDC}

		'fiscal variables for VAR
		GENR t_{%IDC} = 100*((rev_{%IDC}/gdpv{%IDC}) - (rev_{%IDC}(-1)/gdpv{%IDC}(-1)))							
		GENR g_{%IDC} = 100*(((exp_{%IDC} + transf_{%IDC})/gdpv{%IDC}) - ((exp_{%IDC}(-1) + transf_{%IDC}(-1))/gdpv{%IDC}(-1)))

		'fiscal shocks
		GENR imf_tot_ut{%IDC} = imf_tax_ut{%IDC} + imf_spnd_ut{%IDC}													
		GENR imf_tot_at{%IDC} = imf_tax_att{%IDC} + imf_spnd_att{%IDC}
		GENR imf_tot_at1{%IDC} = imf_tax_att1{%IDC} + imf_spnd_att1{%IDC}
		GENR imf_tot_at2{%IDC} = imf_tax_att2{%IDC} + imf_spnd_att2{%IDC}
		GENR imf_tot_at3{%IDC} = imf_tax_att3{%IDC} + imf_spnd_att3{%IDC}
		GENR imf_tot_at4{%IDC} = imf_tax_att4{%IDC} + imf_spnd_att4{%IDC}
		GENR imf_tot_at5{%IDC} = imf_tax_att5{%IDC} + imf_spnd_att5{%IDC}
		'generate impact-only shocks (no distinction b/w unexpected and anticipated shocks)
		GENR imf_tot_imp{%IDC} = imf_tot_ut{%IDC} + imf_tot_at{%IDC}													
		GENR imf_con_imp{%IDC} = imf_con_ut{%IDC} + imf_con_at{%IDC}
		GENR imf_tra_imp{%IDC} = imf_tra_ut{%IDC} + imf_tra_at{%IDC}
		GENR imf_dir_imp{%IDC} = imf_dir_ut{%IDC} + imf_dir_at{%IDC}
		GENR imf_ind_imp{%IDC} = imf_ind_ut{%IDC} + imf_ind_at{%IDC}
		GENR imf_snyoth_imp{%IDC} = imf_snyc_ut{%IDC} + imf_soth_ut{%IDC} + imf_snyc_at{%IDC} + imf_soth_at{%IDC}
		GENR imf_tnyoth_imp{%IDC} = imf_tnyc_ut{%IDC} + imf_toth_ut{%IDC} + imf_tnyc_at{%IDC} + imf_toth_at{%IDC}
		'generate total anticipated
		GENR imf_tot_atot{%IDC} = imf_tot_at1{%IDC} + imf_tot_at2{%IDC} + imf_tot_at3{%IDC} + imf_tot_at4{%IDC} + imf_tot_at5{%IDC}  
		'generate total plan	
		GENR imf_tot_plan{%IDC} = imf_tax_tot{%IDC} + imf_spnd_tot{%IDC}  	

		'generate aggregate nyc and other												
		GENR imf_snyoth_ut{%IDC} = imf_snyc_ut{%IDC} + imf_soth_ut{%IDC}											
		GENR imf_snyoth_at{%IDC} = imf_snyc_at{%IDC} + imf_soth_at{%IDC}
		GENR imf_snyoth_at1{%IDC} = imf_snyc_at1{%IDC} + imf_soth_at1{%IDC}
		GENR imf_snyoth_at2{%IDC} = imf_snyc_at2{%IDC} + imf_soth_at2{%IDC}
		GENR imf_snyoth_at3{%IDC} = imf_snyc_at3{%IDC} + imf_soth_at3{%IDC}
		'we are forced to generate these variables as follows since eviews fails to unstack series that are perfectly equal across countries, as it is for   imf_snyc_at4,  imf_snyc_at5, which are always 0
		GENR imf_snyoth_at4{%IDC} = 0 + imf_soth_at4{%IDC}
		GENR imf_snyoth_at5{%IDC} = 0 + imf_soth_at5{%IDC}
		'GENR imf_snyoth_at4{%IDC} = imf_snyc_at4{%IDC} + imf_soth_at4{%IDC}
		'GENR imf_snyoth_at5{%IDC} = imf_snyc_at5{%IDC} + imf_soth_at5{%IDC}
		GENR imf_snyoth_atot{%IDC} = imf_snyoth_at1{%IDC} + imf_snyoth_at2{%IDC} + imf_snyoth_at3{%IDC} + imf_snyoth_at4{%IDC} + imf_snyoth_at5{%IDC}
		GENR imf_tnyoth_ut{%IDC} = imf_tnyc_ut{%IDC} + imf_toth_ut{%IDC}
		GENR imf_tnyoth_at{%IDC} = imf_tnyc_at{%IDC} + imf_toth_at{%IDC}
		GENR imf_tnyoth_at1{%IDC} = imf_tnyc_at1{%IDC} + imf_toth_at1{%IDC}
		GENR imf_tnyoth_at2{%IDC} = imf_tnyc_at2{%IDC} + imf_toth_at2{%IDC}
		GENR imf_tnyoth_at3{%IDC} = imf_tnyc_at3{%IDC} + imf_toth_at3{%IDC}
		GENR imf_tnyoth_at4{%IDC} = imf_tnyc_at4{%IDC} + imf_toth_at4{%IDC}
		'we are forced to generate these variables as follows since eviews fails to unstack series that are perfectly equal across countries, as it is for   imf_tnyc_at5, which is always 0
		GENR imf_tnyoth_at5{%IDC} = 0 + imf_toth_at5{%IDC}
		'GENR imf_tnyoth_at5{%IDC} = imf_tnyc_at5{%IDC} + imf_toth_at5{%IDC}
		GENR imf_tnyoth_atot{%IDC} = imf_tnyoth_at1{%IDC} + imf_tnyoth_at2{%IDC} + imf_tnyoth_at3{%IDC} + imf_tnyoth_at4{%IDC} + imf_tnyoth_at5{%IDC}

		'generate aggregate future components
		GENR imf_tax_atot{%IDC} = imf_tax_att1{%IDC} + imf_tax_att2{%IDC} + imf_tax_att3{%IDC} + imf_tax_att4{%IDC} + imf_tax_att5{%IDC}  
		GENR imf_con_atot{%IDC} = imf_con_at1{%IDC} + imf_con_at2{%IDC} + imf_con_at3{%IDC} + imf_con_at4{%IDC} + imf_con_at5{%IDC}	
		GENR imf_tra_atot{%IDC} = imf_tra_at1{%IDC} + imf_tra_at2{%IDC} + imf_tra_at3{%IDC} + imf_tra_at4{%IDC} + imf_tra_at5{%IDC}
		GENR imf_dir_atot{%IDC} = imf_dir_at1{%IDC} + imf_dir_at2{%IDC} + imf_dir_at3{%IDC} + imf_dir_at4{%IDC} + imf_dir_at5{%IDC}		
		GENR imf_ind_atot{%IDC} = imf_ind_at1{%IDC} + imf_ind_at2{%IDC} + imf_ind_at3{%IDC} + imf_ind_at4{%IDC} + imf_ind_at5{%IDC}	

NEXT

'extend the time range of the dataset to include simulation years
PAGESELECT TimeSeries 																											  	
PAGESTRUCT(end=@LAST+!HORZ+15) 
PAGESELECT TimeSeries

'create time dummies
FOR %YEAR {%LIST_YEARS} 																											
	SMPL @ALL
	GENR dummy_{%YEAR}=0
	SMPL %YEAR %YEAR
	dummy_{%YEAR}=1
NEXT


