'*******************************************************************
'this program calibrates the state indicator F(s) and graphs it
'*******************************************************************
'setting missing values for IRL (for 1979 and 1980 we use the 1981 value - the first available)
SMPL 1979 1980 				
y_pcirl = @ELEM(y_pcirl, "1981")
g_irl = @ELEM(g_irl, "1981")
t_irl =	@ELEM(t_irl, "1981")
	
FOR %IDC {%LIST}				
		'special case for DEU because the first year available for output per capita growth is 1992															
		IF %IDC = "DEU" THEN	
		'computing moving average of output, normalization and percent of recession in the sample considered (that on which we have obs for output growth)
		SMPL 1994 !YEAR 																	
		GENR 		ma_y_{%IDC} = (y_pc{%IDC}(-2) + y_pc{%IDC}(-1))/2
		GENR 		mean_{%IDC} = @MEAN(ma_y_{%IDC})
		GENR 		sd_{%IDC} = @STDEV(ma_y_{%IDC})
		SMPL 1994-2 !YEAR
		GENR 		recessions_{%IDC} = (y_pc{%IDC} < 0)
		SCALAR	 	n_rec_{%IDC} = @SUM(recessions_{%IDC})
		SCALAR 	prob_rec_{%IDC} = n_rec_{%IDC}/(!YEAR-1994+3)
		SCALAR 	prob_exp_{%IDC} = 1-prob_rec_{%IDC}
		!QUANTILE_{%IDC} = prob_exp_{%IDC}										
		'here starts the calibration for gamma
		SMPL 1994 !year 																			
		SCALAR 	gamma_{%IDC} = 0
			FOR !i = 1 TO 10000
			gamma_{%IDC} = !i*0.001
			GENR	 fs_{%IDC} = (exp(-gamma_{%IDC}*((y_pc{%IDC}(-2)+y_pc{%IDC}(-1)-2*mean_{%IDC})*0.5)/sd_{%IDC}))/(1+(exp(-gamma_{%IDC}*((y_pc{%IDC}(-2)+y_pc{%IDC}(-1)-2*mean_{%IDC})*0.5)/sd_{%IDC})))
				IF @QUANTILE(fs_{%IDC}, !QUANTILE_{%IDC})<=0.8 THEN 
			NEXT
				ELSE
				EXITLOOP
				ENDIF	
'		SMPL !YEAR+1 @LAST			check if this is still needed or not
'		mean_{%IDC} = @ELEM(mean_{%IDC}, "2000")
'		sd_{%IDC} = @ELEM(sd_{%IDC}, "2000")
		ELSE
		'computing moving average of output, normalization and percent of recession in the sample considered (that on which we have obs for output growth)
		SMPL !START !YEAR 															
		GENR 		ma_y_{%IDC} = (y_pc{%IDC}(-2) + y_pc{%IDC}(-1))/2
		GENR 		mean_{%IDC} = @MEAN(ma_y_{%IDC})
		GENR 		sd_{%IDC} = @STDEV(ma_y_{%IDC})
		SMPL !START-2 !YEAR
		GENR 		recessions_{%IDC} = (y_pc{%IDC}<0)
		SCALAR 	n_rec_{%IDC} = @SUM(recessions_{%IDC})
		SCALAR 	prob_rec_{%IDC} = n_rec_{%IDC}/(!YEAR-!START+3)
		SCALAR 	prob_exp_{%IDC} = 1-prob_rec_{%IDC}
		!QUANTILE_{%IDC} = prob_exp_{%IDC}
		'here starts the calibration for gamma
		SMPL !START !YEAR 																
		SCALAR 	gamma_{%IDC} = 0
			FOR !i = 1 TO 10000
			gamma_{%IDC} = !i*0.001
			GENR	fs_{%IDC} = (exp(-gamma_{%IDC}*((y_pc{%IDC}(-2)+y_pc{%IDC}(-1)-2*mean_{%IDC})*0.5)/sd_{%IDC}))/(1+(exp(-gamma_{%IDC}*((y_pc{%IDC}(-2)+y_pc{%IDC}(-1)-2*mean_{%IDC})*0.5)/sd_{%IDC})))
				IF @QUANTILE(fs_{%IDC}, !QUANTILE_{%IDC})<=0.8 THEN 
			NEXT
				ELSE
				EXITLOOP
				ENDIF
		ENDIF
NEXT

'GAMMA'S CALIBRATION RESULTS TABLE
delete TableGamma*
table(7,16) TableGamma
	TableGamma(2, 1)	=  "gamma"
	TableGamma(3, 1)	= "share of time spent in recession"
	!j=2
FOR %IDC {%LIST}
	TableGamma(1, !j)	= %IDC
	TableGamma(2, !j)	= gamma_{%IDC}
	TableGamma(3, !j)	= prob_rec_{%IDC}
	!j = !j+1
NEXT

'generate graphs with the evolution of F(s)
FOR %IDC {%LIST}
	GENR fs_one_{%IDC}=fs_{%IDC}(+1)
	GROUP gfs_{%IDC} fs_one_{%IDC} rec_y_pc{%IDC}
	FREEZE(fig_fsrec_{%IDC}) gfs_{%IDC}.MIXED line(fs_one_{%IDC}) bar(rec_y_pc{%IDC})
	fig_fsrec_{%IDC}.OPTIONS -barspace -outlinebars
	fig_fsrec_{%IDC}.ELEM(1) fillcolor(RGB(224,224,224))
	fig_fsrec_{%IDC}.ELEM(1) lcolor(blue) lpat(solid) lwidth(1)
	fig_fsrec_{%IDC}.AXIS(b) tickson 
	fig_fsrec_{%IDC}.LEGEND(off,inbox,b)
	DELETE gfs_{%IDC}
	DELETE fs_one_{%IDC}
NEXT
fig_fsrec_aus.ADDTEXT(t,font(16)) "AUS"
fig_fsrec_aut.ADDTEXT(t,font(16)) "AUT" 
fig_fsrec_bel.ADDTEXT(t,font(16))  "BEL"
fig_fsrec_can.ADDTEXT(t,font(16))  "CAN"
fig_fsrec_deu.ADDTEXT(t,font(16))  "DEU"
fig_fsrec_dnk.ADDTEXT(t,font(16))  "DNK"
fig_fsrec_esp.ADDTEXT(t,font(16))  "ESP"
fig_fsrec_fra.ADDTEXT(t,font(16))   "FRA"
fig_fsrec_gbr.ADDTEXT(t,font(16))  "GBR"
fig_fsrec_irl.ADDTEXT(t,font(16))  "IRL"
fig_fsrec_ita.ADDTEXT(t,font(16))  "ITA"
fig_fsrec_jpn.ADDTEXT(t,font(16))  "JPN"
fig_fsrec_prt.ADDTEXT(t,font(16))  "PRT"
fig_fsrec_usa.ADDTEXT(t,font(16))  "USA"
fig_fsrec_fin.ADDTEXT(t,font(16))  "FIN"
fig_fsrec_swe.ADDTEXT(t,font(16))  "SWE"
'combine them
%TYPE="fig_fs_merge"
DELETE {%TYPE}*
GRAPH {%TYPE}.MERGE  fig_fsrec_aus fig_fsrec_aut fig_fsrec_bel fig_fsrec_can fig_fsrec_deu fig_fsrec_dnk fig_fsrec_esp fig_fsrec_fra fig_fsrec_gbr fig_fsrec_irl fig_fsrec_ita fig_fsrec_jpn fig_fsrec_prt fig_fsrec_usa fig_fsrec_fin fig_fsrec_swe 
{%TYPE}.align(4,0.8,1)      
{%TYPE}.ADDTEXT(t,font(20,b)) "Evolution of F(s) and Recessions" 
{%TYPE}.OPTIONS backfade(none) backcolor(white) frameaxes(lb) gridpat(dash2)
{%TYPE}.AXIS(left) ticksout -minor font(15) range(0,1)
{%TYPE}.AXIS(bottom) ticksout -minor font(15) 
{%TYPE}.DATELABEL format("yyyy")
DELETE graph_fs_*
DELETE fig_fsrec_*


