'***********************************************************
' COMBINE ALL PROGRAMS
'***********************************************************
!YEAR = 2014 																											'end of estimation sample
!START = 1981 																										'start of estimation sample
!HORZ = 5 																												'years of simulation
!YEAR_S = 2020 																										'set year to start simulation
!REPS = 1000 																										'number of bootstrap repetitions
%DATA_TYPE = "final" 																								'select excel database according to suffix of NewComponents1978-2014_
%LIST = "AUS AUT BEL CAN DEU DNK ESP FIN FRA GBR IRL ITA JPN PRT SWE USA" 		'list of countries
%VARS = "Y_PC_S T_S G_S" 																					'variables in the VAR
%LIST_YEARS = "1981 1982 1983 1984 1985 1986 1987 1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006 2007 2008 2009 2010 2011 2012 2013 2014" 'list of years to create year dummies

INCLUDE dat_imf&conf_transform 																			'loading and trasforming data
INCLUDE fs																											'calibration of the state indicator
INCLUDE style 																										'estimation of the auxiliary system

'IMPULSES
'these programs perform estimation, simulation, bootstrap and collect the responses of the variables after the shock

INCLUDE impulse_spnd_up																						'EB plan shock starting from expansion
INCLUDE impulse_spnd_down																					'EB plan shock starting from recession
INCLUDE impulse_tax_up																						'TB plan shock starting from expansion
INCLUDE impulse_tax_down																					'TB plan shock starting from recession

'note: since we do not consider here the expansion/recession non-linearity, the four programs above differ only for the EB or TB shock (therefore, 'impulse_spnd_up' and 'impulse_spnd_down' give the same result, and similarly 'impulse_tax_up' and 'impulse_tax_down')

FOR %VAR {%VARS}
	INCLUDE dat_imf&conf_graphs																				'generate graphs for the variables in the framework
NEXT
INCLUDE graphs_combine																						'combining graphs
INCLUDE tables																										'generate summary stats tables
INCLUDE scale&save																								'scale and save graphs

